/*
	oop_ex111.java
	Abstract Methods and Abstract Classes
*/


import java.io.*;

//abstract base class
//class shape
abstract class shape
{
	public abstract void move(int x, int y);	//abstract method
	abstract void draw();						//abstract method
}


//concrete derived classes
class circle extends shape
{
	public void move(int x, int y){ System.out.println("do move circle by ("+x+", "+y+")"); }
	void draw(){ System.out.println("do draw circle"); }
}


class triangle extends shape
{
	public void move(int x, int y){ System.out.println("do move triangle by ("+x+", "+y+")"); }
	void draw(){ System.out.println("do draw triangle"); }
}


class square extends triangle
{
	public void move(int x, int y){ System.out.println("do move square by ("+x+", "+y+")"); }
	void draw(){ System.out.println("do draw square"); }
}


class test
{
	public static void main(String[] args)
	{
		//shape sh = new shape();	//cannot instantiate abstract class
		circle ci = new circle();
		triangle tr = new triangle();
		square sq = new square();

		shape [] shapeArr = { ci, tr, sq};	//manage and manipulate using references of abstract class

		for(int i=0; i<shapeArr.length; i++)
			shapeArr[i].draw();

		for(int i=0; i<shapeArr.length; i++)
			shapeArr[i].move(i,i);
	}
}