//oop_ex110.java
//final class in Java


import java.io.*;

final class Supervisor
{
	private String firstname;
	private String lastname;	
	public int deptID;

	public Supervisor(String fnam, String lnam, int d)
	{
		firstname = fnam;
		lastname = lnam;
		deptID = d;
	}
	
	public void print( )
	{
		System.out.println(firstname + " " + lastname);
		System.out.println("department id = " + deptID);
	}
}

class Employee
{
	private String firstname;
	private String lastname;	
	public int deptID;

	public Employee(String fnam, String lnam, int d)
	{
		firstname = fnam;
		lastname = lnam;
		deptID = d;
	}
	
	//final public void print( )		//cannot override final method "print"
	public void print( )
	{
		System.out.println(firstname + " " + lastname);
		System.out.println("department id = " + deptID);
	}
}

//class Manager extends Supervisor	//cannot extend final class "Supervisor"
class Manager extends Employee
{
	private int rank;

	public Manager(String fnam, String lnam, int d, int r)
	{
		super(fnam, lnam, d);		// initialize base members
		//deptID = d;				// accessing base member
		//super.deptID = d;			// accessing base member explicitly using super
		rank = r; 					// initialize local members
	}

	public void print( )	// override print
	{
		super.print( );		//calling print() of base class
		System.out.println("rank = " + rank);
	}
}



class test
{
	public static void main(String[] args)
	{
		Employee e1 = new Employee("John", "Micheal", 201);
		Employee e2 = new Employee("Scott", "Well", 201);
		Employee e3 = new Manager("Jerry", "Smith", 201, 8);
		Employee e4 = new Manager("Jane", "Wang", 201, 10);
		
			
		Employee [] eArr = {e1, e2, e3, e4};
		
		for(int i=0; i<4; i++)
			eArr[i].print();
	}
}