//oop_ex113.java
//Interface Inheritance

import java.io.*;



//interfaces
interface printable
{
	public static final int p = 0;	
	public abstract void print( );	
	public abstract void printToFile(String filename);	
}

interface scaleable
{
	public final int s = 0;					
	public abstract void scale(int f);	
}


interface fullFunction extends printable, scaleable
{
	public final int newfinaldata = 0;					
	public abstract void newfunction( );	
}
	


//abstract base class
abstract class shape
{
	public abstract void move(int x, int y);	//abstract method
	abstract void draw();						//abstract method
}



//concrete derived classes
class circle extends shape implements fullFunction
{
	public void move(int x, int y){ System.out.println("do move circle by ("+x+", "+y+")"); }
	void draw(){ System.out.println("do draw circle"); }

	public void print( ){System.out.println("do print circle");}	
	public void printToFile(String filename){System.out.println("do print circle on "+filename);}	

	public void scale(int f){ System.out.println("do scale circle by "+f); }		

	public void newfunction( ){ System.out.println("circle do newfunction"); }		
}


class triangle extends shape implements fullFunction
{
	public void move(int x, int y){ System.out.println("do move triangle by ("+x+", "+y+")"); }
	void draw(){ System.out.println("do draw triangle"); }

	public void print( ){System.out.println("do print triangle");}	
	public void printToFile(String filename){System.out.println("do print triangle on "+filename);}	

	public void scale(int f){ System.out.println("do scale triangle by "+f); }		

	public void newfunction( ){ System.out.println("triangle do newfunction"); }		
}


class square extends triangle implements fullFunction
{
	public void move(int x, int y){ System.out.println("do move square by ("+x+", "+y+")"); }
	void draw(){ System.out.println("do draw square"); }

	public void print( ){System.out.println("do print square");}	
	public void printToFile(String filename){System.out.println("do print square on "+filename);}	

	public void scale(int f){ System.out.println("do square circle by "+f); }		

	public void newfunction( ){ System.out.println("square do newfunction"); }		
}


class test
{
	public static void main(String[] args)
	{
		circle ci = new circle();
		triangle tr = new triangle();
		square sq = new square();

		fullFunction [] shapeArr = { ci, tr, sq};	//manage and manipulate using references of interface

		for(int i=0; i<shapeArr.length; i++)
			shapeArr[i].print();

		for(int i=0; i<shapeArr.length; i++)
			shapeArr[i].printToFile("out.txt");

		for(int i=0; i<shapeArr.length; i++)
			shapeArr[i].scale(i+1);

		for(int i=0; i<shapeArr.length; i++)
			shapeArr[i].newfunction();	
	}
}