// oop_ex114n.cpp
// role playing classes


import java.io.*;


//role playing classes
class Ability
{

}


class Work extends Ability
{
	private	String dept;
	public double salary;
	
	public Work(String d, double s)
	{
		super();
		dept = d;
		salary = s;
	}
	
	public void setDept(String d){ dept = d; }
	public String getDept(){ return dept; }
}


class Study extends Ability
{
	private	String dept;
	public String level;
	
	public Study(String d, String l)
	{
		super();
		dept = d;
		level = l;
	}
	
	public void setStdDept(String d){ dept = d; }
	public String getStdDept(){ return dept; }
}


//base class
class Person
{
	protected String name;

	public Ability ab1;
	public Ability ab2;
	
	public Person(String n)
	{
		name = n;
		ab1 = null;
		ab2 = null;
	}

	public void print()
	{
		System.out.println("Person name = " + name);
	}
}


//derived class
class Staff extends Person
{
	public Staff(String n, String d, double s)
	{
		super(n);
		ab1 = new Work(d, s);
		ab2 = null;
	}

	
	public void print()
	{
		System.out.println("Staff name = " + name);

		Work p1 = (Work)ab1;	//It is known ab1 points to a Work object.
		System.out.println(",who works in " + p1.getDept());
		System.out.println(",whose salary is " + p1.salary);
		System.out.println();
	}
}


class Student extends Person
{
	public Student(String n, String d, String l)
	{
		super(n);
		ab1 = new Study(d, l);
		ab2 = null;
	}

	
	public void print()
	{
		System.out.println("Student name = " + name);

		Study p1 = (Study)ab1; //It is known ab1 points to a Study object.
		System.out.println(",who studies in " + p1.getStdDept());
		System.out.println(",whose level is " + p1.level);
		System.out.println();
	}
}

	
class TA extends Person
{
	private	String course;
	
	public TA(String n, String wd, double s, String sd, String l, String c)
	{
		super(n);
		ab1 = new Work(wd, s);
		ab2 = new Study(sd, l);
		course = c;
	}

	
	public void print()
	{
		System.out.println("TA name = " + name);
		
		Study p2 = (Study)ab2; //It is known ab2 points to a Study object.
		System.out.println(",who studies in " + p2.getStdDept());
		System.out.println(",whose level is " + p2.level);

		Work p1 = (Work)ab1;	//It is known ab1 points to a Work object.
		System.out.println(",who works in " + p1.getDept());		
		System.out.println(",whose salary is " + p1.salary);

		System.out.println(",who works for course " + course);		
		System.out.println();
	}
}

class test
{
	public static void main(String[] args)
	{
		Staff p1 = new Staff("John", "ME", 10000);
		Student p2 = new Student("Mike", "CS", "Senior");
		TA p3 = new TA("Paul", "CT", 6000, "AD", "PhD", "CT5706");

		Person [] p = {p1, p2, p3};
		
		for(int i=0; i<3; i++)
			p[i].print();


		for(int i=0; i<3; i++)
		{
			if(p[i].ab1 instanceof Work)
				System.out.println("I work in " + ((Work)p[i].ab1).getDept()); 

			if(p[i].ab2 instanceof Work)
				System.out.println("I work in " + ((Work)p[i].ab1).getDept()); 
		}


		for(int i=0; i<3; i++)
		{
			if(p[i].ab1 instanceof Study)
				System.out.println("I study in " + ((Study)p[i].ab1).getStdDept()); 

			if(p[i].ab2 instanceof Study)
				System.out.println("I study in " + ((Study)p[i].ab2).getStdDept()); 
		}
	}
}